-----------------------------------------------------------------
--|> FOCUS TARGET FRAME
-------------------------------------------------------------------------------
--> Upvalues
local C_NamePlate_GetNamePlateForUnit = C_NamePlate.GetNamePlateForUnit

--|> FRAME
-----------------------------------------------------------------
FTL_FOCUS_TARGET_FRAME = FTL_FOCUS_TARGET_FRAME or CreateFrame("Frame", "FTL_FOCUS_TARGET_FRAME", UIParent)
FTL_FOCUS_TARGET_FRAME:SetFrameStrata("HIGH")
FTL_FOCUS_TARGET_FRAME:SetPoint("CENTER", UIParent)
FTL_FOCUS_TARGET_FRAME:SetSize(32, 32)
FTL_FOCUS_TARGET_FRAME:SetIgnoreParentAlpha(true)
FTL_FOCUS_TARGET_FRAME:SetAlpha(0)

--> Icon
FTL_FOCUS_TARGET_FRAME.icon = FTL_FOCUS_TARGET_FRAME:CreateTexture(nil, "ARTWORK", FTL_FOCUS_TARGET_FRAME)
FTL_FOCUS_TARGET_FRAME.icon:SetTexture([[interface/addons/FTL/Media/Textures/ftTexture.tga]])
FTL_FOCUS_TARGET_FRAME.icon:SetPoint("CENTER", FTL_FOCUS_TARGET_FRAME, "CENTER")
FTL_FOCUS_TARGET_FRAME.icon:SetSize(32, 32)
FTL_FOCUS_TARGET_FRAME.icon:SetDrawLayer("OVERLAY", 1)
FTL_FOCUS_TARGET_FRAME.icon:SetVertexColor(1, 0.49, 0, 1)
FTL_FOCUS_TARGET_FRAME.icon:SetBlendMode("ADD")

--> Outline
FTL_FOCUS_TARGET_FRAME.outline = FTL_FOCUS_TARGET_FRAME:CreateTexture(nil, "BACKGROUND", FTL_FOCUS_TARGET_FRAME)
FTL_FOCUS_TARGET_FRAME.outline:SetTexture([[interface/addons/FTL/Media/Textures/ftOutline.tga]])
FTL_FOCUS_TARGET_FRAME.outline:SetAllPoints()
FTL_FOCUS_TARGET_FRAME.outline:SetVertexColor(1, 1, 1, 0.8)
FTL_FOCUS_TARGET_FRAME.outline:SetDrawLayer("ARTWORK", 7)
FTL_FOCUS_TARGET_FRAME.outline:SetPoint("CENTER", FTL_FOCUS_TARGET_FRAME, "CENTER")

--> Shadow
FTL_FOCUS_TARGET_FRAME.shadow = FTL_FOCUS_TARGET_FRAME:CreateTexture(nil, "BACKGROUND", FTL_FOCUS_TARGET_FRAME)
FTL_FOCUS_TARGET_FRAME.shadow:SetTexture([[interface/addons/FTL/Media/Textures/ftShadow.tga]])
FTL_FOCUS_TARGET_FRAME.shadow:SetVertexColor(0, 0, 0, 0.5)
FTL_FOCUS_TARGET_FRAME.shadow:SetDrawLayer("BACKGROUND")
FTL_FOCUS_TARGET_FRAME.shadow:SetAllPoints()
FTL_FOCUS_TARGET_FRAME.shadow:SetPoint("CENTER", FTL_FOCUS_TARGET_FRAME, "CENTER")

--|> FUNCTIONS
-----------------------------------------------------------------
--> Hide
function FTL_FOCUS_TARGET_FRAME:Hide()
    if self:GetAlpha() == 0 then
        return
    end
    self:SetAlpha(0)
    self:ClearAllPoints()
end

--> Show
function FTL_FOCUS_TARGET_FRAME:Show()
    if UnitIsUnit("focustarget", "focus") then
        self:Hide()
    end
    if C_NamePlate_GetNamePlateForUnit("focustarget") then
        self:ClearAllPoints()
        self:SetPoint("BOTTOM", C_NamePlate_GetNamePlateForUnit("focustarget"), "CENTER", 0, 30)
        self:SetAlpha(1)
    else
        self:Hide()
    end
end

--> Show Assist
function FTL_FOCUS_TARGET_FRAME:ShowAssist()
    self.icon:SetVertexColor(1, 0, 0.2, 1)
end

--> Hide Assist
function FTL_FOCUS_TARGET_FRAME:HideAssist()
    self.icon:SetVertexColor(1, 0.49, 0, 1)
    -- self:Show()
end

--> Check For Assist
function FTL_FOCUS_TARGET_FRAME:CheckForAssist()
    if UnitIsUnit("target", "focustarget") then
        self:ShowAssist()
    else
        self:HideAssist()
    end
end
